#include <string.h>
#include <dlfcn.h>
#include <stdlib.h>
#include <stdio.h>

int main()
{
    char *dlhandle;
    void (*init_func_ptr)();
    char *dlenv = getenv("PERL_DL_NOLAZY");
    
    if(dlenv) {
        printf("dlopen() with RTLD_NOW\n");
        dlhandle = dlopen("./Tcl.so", RTLD_NOW);
    }
    else {
        printf("dlopen() with RTLD_LAZY\n");
        dlhandle = dlopen("./Tcl.so", RTLD_LAZY);
    }
    if (!dlhandle) {
        printf("dlopen() failed!\n");
        return -1;
    }
        
    init_func_ptr = (void(*)) dlsym(dlhandle, "NpInitialize");
    init_func_ptr();
}
